/*
 * Copyright (c) 2003, Morpho Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *	  this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *	  this list of conditions and the following disclaimer in the documentation
 *	  and/or other materials provided with the distribution.
 * 3. Neither the name of the Morpho Project nor the names of its contributors
 *	  may be used to endorse or promote products derived from this software
 *	  without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package jp.morpho.webapp.servlet.jsp.tagext.validator;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;

import jp.morpho.webapp.servlet.jsp.tagext.BaseTag;
import jp.morpho.webapp.validator.ValidationState;

/**
 * <P>
 * w肳ꂽtB[hɑ΂郁bZ[W擾܂B
 * </P>
 * @author Kumiko Hiroi
 */
public class MessagesTag
	extends BaseTag
{
	/**
	 * <P>
	 * MessagesTag 쐬܂B
	 * </P>
	 */
	public MessagesTag()
	{
		super();
	}

	/**
	 * <P>
	 * name Ԃ܂B
	 * </P>
	 * @return name 
	 */
	public String getName()
	{
		return getAttributeMap().getString("name");
	}

	/**
	 * <P>
	 * name ݒ肵܂B
	 * </P>
	 * @param name name 
	 */
	public void setName(String name)
	{
		getAttributeMap().putString("name", name);
	}

	/**
	 * <P>
	 * prefix Ԃ܂B
	 * </P>
	 * @return prefix 
	 */
	public String getPrefix()
	{
		return getAttributeMap().getString("prefix");
	}

	/**
	 * <P>
	 * suffix Ԃ܂B
	 * </P>
	 * @return suffix 
	 */
	public String getSuffix()
	{
		return getAttributeMap().getString("suffix");
	}

	/**
	 * <P>
	 * prefix ݒ肵܂B
	 * </P>
	 * @param prefix prefix 
	 */
	public void setPrefix(String prefix)
	{
		getAttributeMap().putString("prefix", prefix);
	}

	/**
	 * <P>
	 * suffix ݒ肵܂B
	 * </P>
	 * @param suffix suffix 
	 */
	public void setSuffix(String suffix)
	{
		getAttributeMap().putString("suffix", suffix);
	}

	/**
	 * <P>
	 * Jn^ȌłB
	 * </P>
	 * @return EVAL_BODY_BUFFERED
	 * @see javax.servlet.jsp.tagext.Tag#doStartTag()
	 */
	public int doStartTag() throws JspException
	{
		StringBuffer buf = new StringBuffer();
		String[] messages = null;

		ValidationState vs = ValidationState.getInstance((HttpServletRequest)pageContext.getRequest());

		if (this.getAttributeMap().containsKey("name"))
		{
			messages = vs.getMessages(this.getName());
		}
		else
		{
			messages = vs.getMessages();
		}

		for (int i = 0; i < messages.length; i++)
		{
			if(this.getAttributeMap().containsKey("prefix"))
			{
				buf.append(this.getPrefix());
			}

			buf.append(messages[i]);

			if(this.getAttributeMap().containsKey("suffix"))
			{
				buf.append(this.getSuffix());
			}
		}

		try
		{
			JspWriter out = pageContext.getOut();
			out.print(buf.toString());
		}
		catch (IOException e)
		{
			throw new JspException(e.getMessage());
		}

		return super.doStartTag();
	}

}
