/*
 * Copyright (c) 2003, Morpho Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 3. Neither the name of the Morpho Project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package jp.morpho.webapp.validator;


/**
 * <P>
 * HTTP p[^̑Ó؂邽߂̒ۃNXłB
 * </P>
 * @author Kenichi Fukuda
 */
public abstract class AbstractFieldValidator implements FieldValidator
{
	private String name = null;
	private String compareFieldName = null;
	private String compareOperator = null;
	private boolean required = false;

	/**
	 * <P>
	 * tB[hݒ肵܂B
	 * </P>
	 * @param name tB[h
	 */
	public void setFieldName(String name)
	{
		this.name = name;
	}

	/**
	 * <P>
	 * tB[hԂ܂B
	 * </P>
	 * @return tB[h
	 */
	public String getFieldName()
	{
		return name;
	}

	/**
	 * <P>
	 * ̃tB[hƔrtB[h̖OԂ܂B
	 * </P>
	 * @return ̃tB[hƔrtB[h̖O
	 */
	public String getCompareFieldName()
	{
		return compareFieldName;
	}

	/**
	 * <P>
	 * rZqԂ܂B
	 * </P>
	 * @return rZq
	 */
	public String getCompareOperator()
	{
		return compareOperator;
	}

	/**
	 * <P>
	 * ̃tB[hƔrtB[h̖Oݒ肵܂B
	 * </P>
	 * @param name ̃tB[hƔrtB[h̖O
	 */
	public void setCompareFieldName(String name)
	{
		compareFieldName = name;
	}

	/**
	 * <P>
	 * rZqݒ肵܂B
	 * </P>
	 * @param operator rZq
	 */
	public void setCompareOperator(String operator)
	{
		compareOperator = operator;
	}

	/**
	 * <P>
	 * K{͂̏ꍇ true Ԃ܂B
	 * </P>
	 * @return K{͂̏ꍇ true
	 */
	public boolean getRequired()
	{
		return required;
	}

	/**
	 * <P>
	 * K{͂̏ꍇ true ݒ肵܂B
	 * </P>
	 * @param required K{͂̏ꍇ true
	 */
	public void setRequired(boolean required)
	{
		this.required = required;
	}

	/**
	 * <P>
	 * Ó̌؂sꍇ true Ԃ܂B
	 * </P>
	 * @return Ó̌؂sꍇ true
	 */
	protected boolean isValidate(String value)
	{
		if (this.getRequired() == false)
		{
			if (value == null || value.equals(""))
			{
				return false;
			}
		}
		return true;
	}

	/**
	 * <P>
	 * HTTP p[^ɒlݒ肳Ă邩ǂ؂܂B
	 * K{͂łȂꍇ́A؏s܂B
	 * </P>
	 * @param value ؂ HTTP p[^
	 * @throws ValidationException Ó؂Ƃɖ肪oꂽꍇ
	 */
	protected void validateRequired(Object value) throws ValidationException
	{
		if (this.getRequired())
		{
			if (value == null)
			{
				throw new ValidationException("value is required");
			}
			if (value instanceof String)
			{
				if (((String)value).equals(""))
				{
					throw new ValidationException("value is required");
				}
			}
		}
	}

}
